
/**
 * Simple program to create some linked lists.
 */

class driver {
    public static void main(String[] args) {
	demos1();
	System.out.println("================");
	LinkedStrList.demos();
    }

    /*
     * Some demos on building lists; not really a member
     */
    static public void demos1()
    {
	LinkedStrList ls = new LinkedStrList();
	ls.addfirst("durian");
	ls.addfirst("cranberry");
	ls.addfirst("breadfruit");
	ls.addfirst("artichoke");
	ls.printList();
        System.out.println("============");
	ls = new LinkedStrList();
	ls.addfirst("eggplant");
	ls.insertBefore(0, "cherry");
	ls.insertBefore(1, "daikon");
	ls.insertBefore(2, "durian");
	ls.insertBefore(0, "canteloupe");
	ls.printList();
       
        
    }
}

class LinkedStrList
{ 

    /**
     * Constructor for objects of class LinkedStrList
     */
    public static class Cell {
       private String data_;
       private Cell next_;
       public Cell(String s, Cell n) {data_ = s; next_ = n;}
       public String data() {return data_;}
       public Cell next() {return next_;}
       public void setData(String s) {data_ = s;}
       public void setNext(Cell c)   {next_ = c;}
    }

    private Cell head;
    
    public LinkedStrList() {head = null;}
    
    public void addfirst(String data) {head = new Cell(data, head);}
    
    public void printList() {
        Cell p = head;
        while (p!=null) {
            System.out.println(p.data());
            p = p.next();
        }
    }
        
    public  boolean equals (Object theOther) {
	    if (! (theOther instanceof LinkedStrList)) return false;
	    LinkedStrList ll = (LinkedStrList) theOther;
        if (ll == null) return false;
        return equals(head,  ll.head);
    }
    
    private boolean equals(Cell p1, Cell p2) {
        if (p1==null && p2==null) return true;             // both lists empty
        if (p1==null || p2==null) return false;            // one empty, one not
        if (! p1.data().equals(p2.data())) return false;   // unequal first elment
        return equals(p1.next(), p2.next());                // recursive case
    }
    
    public int hashCode() {
	Cell p = head;
	int hash = 0;
	while (p!= null) {
	    hash = hash ^ p.data().hashCode();
	    p = p.next();
	}
	return hash;
    }

    public LinkedStrList clone() {
        LinkedStrList c = new LinkedStrList();
        c.head = clonecells(head);
        return c;
    }
    
    // clones a list of cells; uses recursion
    private Cell clonecells(Cell c) {
        if (c==null) return null;
        return new Cell(c.data(), clonecells(c.next()));
    }
    
    
    /*# implement the following */
    public int size() {
        return 0;
    }
    
    /*# the following FAILS TO CHECK IF n IS TOO BIG */
    public String Get(int n) {
        Cell p = head;
        while (n>0) {
            p = p.next();
            n--;
        }
        return p.data();
    }
    
    /*# add this */
    public void Set(int n, String val) {
    }
    
    /*# add this */
    public void insertAfter (int n, String val) {
    }
    
    public void insertBefore(int n, String val) {
	if (n==0) {		// insert at head
	    head = new Cell(val, head);
	} else {
	    Cell p = head;
	    for (int i=0; i<n-1; i++) p = p.next();	// p now points to PREVIOUS cell
	    p.setNext(new Cell(val, p.next())); 
	}
    }

    /*# add this */
    public LinkedStrList reverse() {
        return null;
    }

    // Cell-level demos
    static public void demos()
    {
        Cell L = null;
        L = new Cell("cherry", L);
        L = new Cell("blueberry", L);
        L = new Cell("apricot", L);
        
        Cell p;
        p = L;
        while (p != null) {
            System.out.println(p.data());
            p = p.next();
        }
        System.out.println("=========");
        
        p = L;
        p = p.next();
        Cell q = new Cell("grape", p.next());
        p.setNext(q);
        
        p = L;
        while (p != null) {
            System.out.println(p.data());
            p = p.next();
        }
    }
        
}